// Generated file

// clang-format off
const char *g_transvoxel_minimal_shader =
"shader_type spatial;\n"
"\n"
"// From Voxel Tools API\n"
"uniform int u_transition_mask;\n"
"\n"
"float get_transvoxel_secondary_factor(int idata) {\n"
"	int cell_border_mask = idata & 63; // Which sides the cell is touching\n"
"	int vertex_border_mask = (idata >> 8) & 63; // Which sides the vertex is touching\n"
"	// If the vertex is near a side where there is a low-resolution neighbor,\n"
"	// move it to secondary position\n"
"	int m = u_transition_mask & cell_border_mask;\n"
"	float t = float(m != 0);\n"
"	// If the vertex lies on one or more sides, and at least one side has no low-resolution neighbor,\n"
"	// don't move the vertex.\n"
"	t *= float((vertex_border_mask & ~u_transition_mask) == 0);\n"
"	\n"
"	// Debugging\n"
"	//t *= 0.5 + 0.5 * sin(TIME * 4.0);\n"
"	//t *= 2.0;\n"
"\n"
"	return t;\n"
"}\n"
"\n"
"vec3 get_transvoxel_position(vec3 vertex_pos, vec4 fdata) {\n"
"	int idata = floatBitsToInt(fdata.a);\n"
"\n"
"	// Move vertices to smooth transitions\n"
"	float secondary_factor = get_transvoxel_secondary_factor(idata);\n"
"	vec3 secondary_position = fdata.xyz;\n"
"	vec3 pos = mix(vertex_pos, secondary_position, secondary_factor);\n"
"\n"
"	// If the mesh combines transitions and the vertex belongs to a transition,\n"
"	// when that transition isn't active we change the position of the vertices so\n"
"	// all triangles will be degenerate and won't be visible.\n"
"	// This is an alternative to rendering them separately,\n"
"	// which has less draw calls and less mesh resources to create in Godot.\n"
"	// Ideally I would tweak the index buffer like LOD does but Godot does not\n"
"	// expose anything to use it that way.\n"
"	int itransition = (idata >> 16) & 0xff; // Is the vertex on a transition mesh?\n"
"	float transition_cull = float(itransition == 0 || (itransition & u_transition_mask) != 0);\n"
"	pos *= transition_cull;\n"
"\n"
"	return pos;\n"
"}\n"
"\n"
"void vertex() {\n"
"	VERTEX = get_transvoxel_position(VERTEX, CUSTOM0);\n"
"}\n";
// clang-format on
